#pragma once
//==========================================================================
// TrayIcon.h
//   ^XNo[̃gCɃACRi[@\
//==========================================================================



//
// CxgXi
//

class TrayIconEventHandler
{
	virtual HMENU on_menu() { return NULL; }
	virtual void  on_command( HMENU menu, UINT id ) {}
	friend class TrayIcon;
};



//
// gCACR
//

class TrayIcon
	: msg_receiver
{
public:
	TrayIcon( TrayIconEventHandler* evhan, const TCHAR* dummyWndName=TEXT("TrayIcon") );
	~TrayIcon();

	void setIcon(  HICON  icn );
	void setTip ( tstring str );

private:
	bool send_ADD();
	bool send_MODIFY();
	bool send_DELETE();
	bool send_SETVERSION();

private:
	static UINT getTaskbarCreatedMsg();
	static UINT getStdNotifyMsg();
	virtual LRESULT on_message( UINT msg, WPARAM wp, LPARAM lp );
	void readd();

private:
	NOTIFYICONDATA              config;
	TrayIconEventHandler* const evhan;
};
