#pragma once
//==========================================================================
// DirectX.h
//   DirectX Graphics ܂̂ȏƂ
//==========================================================================

class DirectXManager
	: noncopyable
{
public:
	// BDirectXManagerCX^XԂ
	static DirectXManager& uniqueInstance()
	{
		static DirectXManager man;
		return man;
	}

	// DirectX8 gp\ǂH
	bool isAvail() const { return direct3D != NULL; }

	// foCX̐ݒ
	IDirect3DDevice8* setUpDevice( HWND wnd );

	// setUpDeviceɌĂł悢\bh
	IDirect3DDevice8*  device() const { return direct3DDevice; }
	IDirect3DTexture8* loadTexture( const tstring& fileName );

private:
	DirectXManager();
	~DirectXManager();

private:
	HMODULE           d3d_dll;
	IDirect3D8*       direct3D;
	IDirect3DDevice8* direct3DDevice;
	SIZE              currentBufferSize;
};
